unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  directx,DXDraws, DXClass, DXInput, DXSounds, DXPlay, joffaclass, math, registry;


type objtype = record
               ox,oy,xx,yy : single;
               py,vx,vy,ovy : single;
               typo : integer;
               ax,ay : single;
               direction : byte;
               tag : string[10];
               pic : single;
               energy,itag,stall,invince : integer;
               istrampo,crashx,crashy : boolean;
               pusher,pushable,blockcrash : boolean;
               gravity : boolean;
               end;

type
  TMainForm = class(TDXForm)
    DXDraw1: TDXDraw;
    DXTimer1: TDXTimer;
    DXImageList1: TDXImageList;
    DXInput1: TDXInput;
    DXSound1: TDXSound;
    DXSfx1: TDXWaveList;
    DXMusic1: TDXWaveList;
    DXPlay1: TDXPlay;
    procedure DXTimer1Timer(Sender: TObject; LagCount: Integer);
    procedure DXPlay1Message(Sender: TObject; From: TDXPlayPlayer;
      Data: Pointer; DataSize: Integer);
    procedure UpdateGamma;
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DXDraw1InitializeSurface(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure DXDraw1Click(Sender: TObject);
  private
    { Private declarations }
    Slide : Boolean;
  public
    { Public declarations }

    function CreateObjectOfBlock(blockno : integer; xx,yy : single) : integer;
    Procedure PlaySoundFX(xx,yy : single; sample : integer);
    procedure calcbmask(imageno : integer);
    procedure killenemy(objnr : integer);
    procedure killjoffa(objnr,enemynr : integer);
    function pushobjsx(cx,cy,dx : single; discard,level : integer) : boolean;
    function pushobjsy(cx,cy : single; var dy : single; discard,level : integer) : boolean;
    Procedure MoveObject(obj : integer; dvx,dvy : single; level : integer);
    Procedure ProcessObjs;
    Procedure PlayerInput(PlayerObj : integer; dxistates : tdxinputstates);
    procedure PlayGame;
    Procedure loadlevel(levelfilename : string);
    procedure loadgfx;
    procedure LoadWorld(dff : string);
    Procedure InitApp;
    Procedure InitGame;
    Function GetHandle : integer;
    procedure SwitchMode;
    Procedure SetObj(ObjNo : integer; Obj : objtype);
  end;

const DefaultWidth = 1024;
      DefaultHeight = 512;
      DefaultLayers = 3;
      maxplayers = 16;
//      maxobjs = 256;
      LiftSpeed = 1;

type levelextrainfotype = record
 startx,starty : integer;
 layers : integer;
 width,height : integer;
 name : string[32];
 megaobjs,bypass,background, backobjs, sprites : string[32];
 scrollbackground : byte;
 end;


type leveltype = record
 info : levelextrainfotype;
 l : array of array of array of smallint;
 filename : string[255];
 currentfile : string[255];
 end;


type playertype = record
                  id : cardinal;
                  objnr : integer;
                  score : integer;
                  invince : integer;
                  name : string[255];
                  end;


type gametype = record
                players : array[0..maxplayers-1] of playertype;
                level : leveltype;
                objs : array of objtype;
                scrollx,scrolly : integer;
                done : array[0..15] of boolean;
                fireup : boolean;
                levelscore,score,nextfire : integer;
                gamma : record
                        r,g,b : single;
                        end;
                end;

var
  MainForm: TMainForm;
  Game : gametype;
  currentobj,MyHandle : integer;
  bmask : array[0..1024,0..31,0..31] of boolean;
  playing : boolean = false;
  introframe : integer=0;
  frame : integer=0;
  visiblescore : integer;

Const SnowPixels = 200;
      GameLayer = 1;

var snow : array[0..SnowPixels-1] of record
                                        x,y,z : single;
                                        d : byte;
                                        end;

function deviceBitsPerPixel: integer; 

implementation

uses jUnit2, Unit2, Unit3;

{$R *.DFM}

var GammaRamp: TDDGammaRamp;

function deviceBitsPerPixel: integer;
var
  DC: HDC;
begin
     DC := getDC ( 0 );

     try
        result := GetDeviceCaps ( DC, PLANES ) * GetDeviceCaps(DC, BITSPIXEL );
     finally
        releaseDC ( 0, DC );
     end;
end;

Procedure TMainForm.SetObj(ObjNo : integer; Obj : objtype);
begin
  game.objs[objno]:=obj;
{ with game.objs[objno] do
  begin
    gravity:=obj.gravity;
    xx:=obj.xx;
    yy:=obj.yy;
    vx:=obj.vx;
    vy:=obj.vy;
    typo:=obj.typo;
    ox:=obj.ox;
    oy:=obj.oy;
    py:=obj.py;
    ovy:=obj.ovy;
    ax:=obj.ax;
    ay:=obj.ay;
    direction:=obj.direction;
    tag:=obj.tag;
    pic:=obj.pic;
    energy:=obj.energy;
    itag:=obj.itag;
    stall:=obj.stall;
    invince:=obj.invince;
    istrampo:=obj.istrampo;
    crashx:=obj.crashx;
    crashy:=obj.crashy;
    pusher:=obj.pusher;
    pushable:=obj.pushable;
    blockcrash:=obj.blockcrash;
  end;{}
end;

Procedure TMainForm.SwitchMode;
begin
    DXDraw1.Finalize;

    if doFullScreen in DXDraw1.Options then
    begin
      RestoreWindow;
      DXDraw1.Display.BitCount:=devicebitsperpixel;
      DXDraw1.Cursor := crDefault;
      BorderStyle := bsSingle;
      DXDraw1.Options := DXDraw1.Options - [doFullScreen];
      ClientWidth:=640;
      ClientHeight:=480;
    end else
    begin
      StoreWindow;
      DXDraw1.Display.BitCount:=16;
      DXDraw1.Cursor := crNone;
      BorderStyle := bsNone;
      DXDraw1.Options := DXDraw1.Options + [doFullScreen];
      Top:=0; Left:=0;
    end;

    DXDraw1.Initialize;
    If playing then LoadGFX;
with TRegIniFile.Create('Joffa') do
 begin
 if (dofullscreen in dxdraw1.options) then
  WriteBool('Settings','Fullscreen',True) Else
  WriteBool('Settings','Fullscreen',False);
 Free;
 end;
    
end;

procedure TMainForm.UpdateGamma;
var
  i: Integer;
  r,g,b : integer;
begin
with game do
  for i:=0 to 255 do
  begin
  r := round((i shl 8)*gamma.r);
  g := round((i shl 8)*gamma.g);
  b := round((i shl 8)*gamma.b);
  if r>65534 then r:=65534;
  if g>65534 then g:=65534;
  if b>65534 then b:=65534;

  GammaRamp.Red[i]:=r;
  GammaRamp.Green[i]:=g;
  GammaRamp.Blue[i]:=b;
  end;

  DXDraw1.Primary.GammaControl.SetGammaRamp(0, GammaRamp);
end;

function TMainForm.CreateObjectOfBlock(blockno : integer; xx,yy : single) : integer;
var handl : integer;
begin
result:=-1;
if (blockno=7) then
 begin
 handl:=gethandle;
 game.objs[handl].xx:=xx;
 game.objs[handl].yy:=yy;
 game.objs[handl].pic:=16*4;
 game.objs[handl].typo:=40;
 game.objs[handl].stall:=0;
 game.objs[handl].itag:=-1;

 if game.level.info.layers>=3 then
  if game.level.l[2][trunc(xx) shr 5,trunc(yy) shr 5]<>-1 then
   begin
   game.objs[handl].itag:=game.level.l[2][trunc(xx) shr 5,trunc(yy) shr 5];
   game.level.l[2][trunc(xx) shr 5,trunc(yy) shr 5]:=-1;
   end;
 game.objs[handl].pusher:=true;
 game.objs[handl].pushable:=false;
 result:=handl;
 end;


if (blockno=5) then
 begin
 handl:=gethandle;
 game.objs[handl].xx:=xx;
 game.objs[handl].yy:=yy;
 game.objs[handl].pic:=-blockno;
 game.objs[handl].typo:=77;
 game.objs[handl].pusher:=true;
 game.objs[handl].pushable:=true;
 result:=handl;
 end;

if (blockno>=48) and (blockno<=63) then
 begin
 handl:=gethandle;
 game.objs[handl].xx:=xx;
 game.objs[handl].yy:=yy;
 game.objs[handl].pic:=-blockno;
 game.objs[handl].typo:=50;
 game.objs[handl].tag:=inttostr(blockno-47);
 result:=handl;
 end;

if (blockno>=2) and (blockno<=4) then
 begin
 handl:=gethandle;
 game.objs[handl].xx:=xx;
 game.objs[handl].yy:=yy;
 game.objs[handl].pic:=-blockno;
 game.objs[handl].typo:=78;
 game.objs[handl].gravity:=false;
 if blockno=2 then game.objs[handl].tag:='1';
 if blockno=3 then game.objs[handl].tag:='2';
 if blockno=4 then game.objs[handl].tag:='0';
 result:=handl;
 end;




if (blockno>=2*16) and (blockno<3*16) then
 begin// flyvekloss
 handl:=gethandle;
 game.objs[handl].pusher:=true;
//    game.objs[handl].pushable:=true;
 game.objs[handl].xx:=xx;
 game.objs[handl].yy:=yy;
 game.objs[handl].pic:=-blockno;
 game.objs[handl].typo:=4;
 game.objs[handl].tag:='N'; // Oppover/Nedover/Venstre/Hyre
 game.objs[handl].gravity:=false;
 result:=handl;
 end;

if blockno=0 then
 with game.level.info do
  begin
  startx:=trunc(xx);
  starty:=trunc(yy);
  game.scrollx:=round(xx-dxdraw1.display.width / 2);
  game.scrolly:=round(yy-dxdraw1.display.height / 2);
  result:=0;
  end;

if (blockno>=144) and (blockno<=144+15) then
 begin // Frukt
 handl:=gethandle;
 game.objs[handl].xx:=xx;
 game.objs[handl].yy:=yy;
 game.objs[handl].pic:=2*16+blockno-144;
 game.objs[handl].typo:=78;
 game.objs[handl].gravity:=false;
 result:=handl;
 end;

if (blockno=6) then
 begin
 handl:=gethandle;
 game.objs[handl].xx:=xx;
 game.objs[handl].yy:=yy;
 game.objs[handl].pic:=17;
 game.objs[handl].typo:=2; // trampotopp
 game.objs[handl].istrampo:=true; // trampotopp
 game.objs[handl].pusher:=true;

 handl:=gethandle;
 game.objs[handl].xx:=xx;
 game.objs[handl].yy:=yy;
 game.objs[handl].pic:=16;
 game.objs[handl].typo:=3; // trampo bunn
 result:=handl;
 end;

if (blockno>=16) and (blockno<16+16) then
 begin //fiende
 handl:=gethandle;

 game.objs[handl].energy:=1;
 if blockno=19 then game.objs[handl].energy:=2;
 game.objs[handl].xx:=xx;
 game.objs[handl].yy:=yy;
 game.objs[handl].pic:=0;
//    game.objs[handl].pic:=(l[xx,yy]-16+8)*16;
 game.objs[handl].typo:=100+blockno-16; // fiende
 game.objs[handl].direction:=random(2);;
 game.objs[handl].stall:=0;
 game.objs[handl].pushable:=true;
 game.objs[handl].pusher:=true;

 result:=handl;
 end;
end;

procedure initsnow;
var i : integer;
begin
for i:=0 to snowpixels do
 begin
 Snow[i].X:=random(640);
 Snow[i].Y:=random(480);
 Snow[i].Z:=random(9)+1;
 Snow[i].d:=random(256);
 end;
end;

Procedure TMainForm.PlaySoundFX(xx,yy : single; sample : integer);
var centerdist : single;
begin
centerdist:=sqrt(sqr((game.scrollx+320)-(xx+16))+sqr((game.scrolly+240)-(yy+16)));
if centerdist<320+32 then
 with dxsfx1.items[sample] do
  begin
  volume:=0;pan:=0;
  play(false)
  end;
end;

Function TMainForm.GetHandle : integer;
var i : integer;
    l : integer;
begin
l:=length(game.objs);
for i:=0 to l-1 do
 if (game.objs[i].typo=0) then
  begin
//  if game.lastobj<i then game.lastobj:=i;
  zeromemory(@game.objs[i],sizeof(game.objs[i]));
//default settings
  game.objs[i].gravity:=true;
  result:=i;
  exit;
  end;
setlength(game.objs,l+1);
game.objs[l].gravity:=true;
result:=l;
end;



function isenemy(sxx,syy : integer) : integer; // return obj handle
var i : integeR;
begin
for i:=0 to length(game.objs)-1 do
//i:=1;
 with game.objs[i] do
  if typo>=100 then
   begin
   if (sxx>=xx) and (sxx<=xx+31) and
      (syy>=yy+py) and (syy<=yy+31+py)then
     begin
     isenemy:=i;
     exit;
     end;
   end;
isenemy:=-1;
end;

function isenemytop(sxx,syy : integer) : integer; // return obj handle
var i : integeR;
begin
for i:=0 to length(game.objs)-1 do
//i:=1;
 with game.objs[i] do
  if typo>=100 then
   begin
   if (sxx>=xx) and (sxx<=xx+31) and
      (syy>=yy+py) and (syy<=yy+8+py)then
     begin
     isenemytop:=i;
     exit;
     end;
   end;
isenemytop:=-1;
end;

type hubba = array[0..1] of byte;

procedure TMainForm.calcbmask(imageno : integer);
var p,xx,yy : integer;
    d : ^hubba;
begin
for p:=0 to dximagelist1.Items[imageno].PatternCount-1 do
 begin
 for yy:=0 to 31 do
  begin
  d:=DXImageList1.Items[imageno].Picture.Bitmap.ScanLine[yy+(p shr 4) shl 5];
  for xx:=0 to 31 do
   if (d[(xx+(p mod 16) shl 5)*3+2]=255) and (d[(xx+(p mod 16) shl 5)*3+1]=0) and (d[(xx+(p mod 16) shl 5)*3]=0) or
      (d[(xx+(p mod 16) shl 5)*3+2]=0) and (d[(xx+(p mod 16) shl 5)*3+1]=0) and (d[(xx+(p mod 16) shl 5)*3]=255) then
    begin
    bmask[p,xx,yy]:=true;
    end else bmask[p,xx,yy]:=false;
  end;
 end;
end;

Procedure FixImg16(imgno : integer);
var xx,yy,r,g,b : integer;
    d : ^hubba;

begin
//exit;
mainform.dximagelist1.Items[imgno].picture.Bitmap.PixelFormat:=pf24bit;
for yy:=0 to mainform.dximagelist1.Items[imgno].picture.bitmap.height-1 do
 begin
 d:= mainform.DXImageList1.Items[imgno].Picture.Bitmap.ScanLine[yy];
 for xx:=0 to mainform.dximagelist1.Items[imgno].picture.bitmap.width-1 do
  begin
  b:=d[xx*3+0];
  g:=d[xx*3+1];
  r:=d[xx*3+2];
//  if r shr 3 shl 3 <> r then
  if (r+g shl 8+b shl 16 <> clred) then
  begin
    r:=round((r-8+random(16)) / 8) shl 3;
    g:=round((g-4+random(8)) / 4) shl 2;
    b:=round((b-8+random(16)) / 8) shl 3;
    if b>255 then b:=255;
    if r>255 then r:=255;
    if g>255 then g:=255;
    if r<0 then r:=0;
    if g<0 then g:=0;
    if b<0 then b:=0;
  end;{}
  d[xx*3+0]:=b;//5
  d[xx*3+1]:=g;//6
  d[xx*3+2]:=r;//5
  end;
 end;
end;


Procedure FixImg8(imgno : integer);
var xx,yy,r,g,b : integer;
    d : ^hubba;

begin
mainform.dximagelist1.Items[imgno].picture.Bitmap.PixelFormat:=pf24bit;
for yy:=0 to mainform.dximagelist1.Items[imgno].picture.bitmap.height-1 do
 begin
 d:= mainform.DXImageList1.Items[imgno].Picture.Bitmap.ScanLine[yy];
 for xx:=0 to mainform.dximagelist1.Items[imgno].picture.bitmap.width-1 do
  begin
  r:=d[xx*3+2];
  g:=d[xx*3+1];
  b:=d[xx*3+0];
  if (r <> 0) and (r<>255) then
   begin
   r:=round((r-32+random(64)) / 32) shl 5;
   if r>=255 then r:=254;
   end;

  if (g <> 0) and (g<>255) then
   g:=round((g-32+random(64)) / 32) shl 5;

  if (b <> 0) and (b<>255) then
   b:=round((b-64+random(128)) / 64) shl 6;

  if b>255 then b:=255;
  if r>255 then r:=255;
  if g>255 then g:=255;
  if r<0 then r:=0;
  if g<0 then g:=0;
  if b<0 then b:=0;

  d[xx*3+2]:=r;//3
  d[xx*3+1]:=g;//3
  d[xx*3+0]:=b;//2
  end;
 end;
end;


procedure flipimg(from,fto : integer);
var p,xx,yy : integer;
    d,d2 : ^hubba;
begin
mainform.dximagelist1.Items[fto].picture.Bitmap.PixelFormat:=pf32bit;
mainform.dximagelist1.Items[from].picture.Bitmap.PixelFormat:=pf32bit;

mainform.DXImageList1.Items[fto].Picture.Bitmap.Width:=
 mainform.DXImageList1.Items[from].Picture.Bitmap.Width;

mainform.DXImageList1.Items[fto].Picture.Bitmap.Height:=
 mainform.DXImageList1.Items[from].Picture.Bitmap.Height;

for p:=0 to mainform.dximagelist1.Items[from].PatternCount-1 do
 begin
 for yy:=0 to 31 do
  begin
  d:= mainform.DXImageList1.Items[from].Picture.Bitmap.ScanLine[yy+(p shr 4) shl 5];
  d2:= mainform.DXImageList1.Items[fto].Picture.Bitmap.ScanLine[yy+(p shr 4) shl 5];
  for xx:=0 to 31 do
   begin
   if xx>31 then break;
   d2[(xx+(p mod 16) shl 5)*4+0]:= d[(31-xx+(p mod 16) shl 5)*4+0]; //r
   d2[(xx+(p mod 16) shl 5)*4+1]:= d[(31-xx+(p mod 16) shl 5)*4+1]; //g
   d2[(xx+(p mod 16) shl 5)*4+2]:= d[(31-xx+(p mod 16) shl 5)*4+2]; //b
   end;
  end;
 end;

mainform.dximagelist1.Items[fto].picture.Bitmap.PixelFormat:=pf24bit;
mainform.dximagelist1.Items[from].picture.Bitmap.PixelFormat:=pf24bit;
end;

function isbonus(sxx,syy : integer) : integer; // return obj handle
var i : integeR;
begin
for i:=0 to length(game.objs)-1 do
//i:=1;
 with game.objs[i] do
  if typo=78 then
   begin
   if (sxx>=xx-16) and (sxx<=xx+16) and
      (syy>=yy-16) and (syy<=yy+16)then
     begin
     game.score:=game.score+(typo-77)*100;
     result:=i;
         with game.gamma do
          begin
          r:=1.1; g:=1.1; b:=1.1;
          end;
     exit;
     end;
   end;
result:=-1;
end;

function isdoor(sxx,syy : integer) : integer; // return obj handle
var i : integeR;
begin
for i:=0 to length(game.objs)-1 do
//i:=1;
 with game.objs[i] do
  if typo=50 then
   begin
   if (sxx>=xx-16) and (sxx<=xx+16) and
      (syy>=yy-16) and (syy<=yy+16)then
     begin
     result:=i;
     exit;
     end;
   end;
result:=-1;
end;






Function IsBlock(xx,yy : integer) : integer;
var dx,dy : integer;
    gl : integer;
begin
if xx<0 then begin;result:=1;exit;end;
if xx>game.level.info.width shl 5-1 then begin;result:=1;exit;end;
if yy>game.level.info.height shl 5-1 then begin;result:=-1;exit;end;
if yy<-28 then begin;result:=1;exit;end;
if yy<0 then begin;result:=-1;exit;end;

dx:=xx-((xx shr 5) shl 5);
dy:=yy-((yy shr 5) shl 5);

//if mainform.DXImageList1.Item[1].patterns.pixe
gl:=game.level.l[GameLayer][xx shr 5,yy shr 5];


if gl<0 then
 begin
 result:=gl;
 end else if bmask[gl,dx,dy] then result:=-1 else result:=gl;
end;

var lo : integer;

function isobj(cx,cy : single; discard : integer) : integer;
var i : integer;
begin
result:=-1;
for i:=0 to length(game.objs)-1 do
 if (i<>discard) then
 with game.objs[i] do
  if typo>0 then
   if (cx>=xx) and (cx<=xx+31) and
      (cy>=yy) and (cy<=yy+31) then
       begin
       result:=i;lo:=i;
       break;
       end;
end;

procedure TMainForm.killenemy(objnr : integer);
begin
with game.objs[objnr] do
 begin
 game.score:=game.score+(typo-100)*200;
 dec(energy);stall:=10;
 if energy=0 then
  begin
  stall:=255;
  pic:=8+(typo-100+7)*16;
  typo:=99;
  pushable:=false;pusher:=false;
  tag:='DD';
  invince:=255;
  end;
 playsoundfx(xx+16,yy+16,4);
 with game.gamma do
  begin
  r:=1;g:=1.5; b:=1;
  end;
 end;
end;

procedure tmainform.killjoffa(objnr,enemynr : integer);
begin
with game.objs[objnr] do
 begin
 if pic=7 then
  begin
  killenemy(enemynr);
  crashx:=false;
  game.objs[enemynr].ay:=-12;
  game.objs[enemynr].oy:=game.objs[enemynr].yy;
  game.objs[enemynr].vx:=vx*2;
  exit;
  end;
 if tag='' then
  begin
  PlaySoundFX(xx,yy,7);
  typo:=99;
  end else
  begin
  PlaySoundFX(xx,yy,7);
  tag:='';
  end;
 pic:=8;
 stall:=255;
 ay:=-8;
 oy:=yy;
 with game.gamma do
  begin
  r:=2;g:=0.5; b:=0.5;
  end;
 end;
end;


function tmainform.pushobjsx(cx,cy,dx : single; discard,level : integer) : boolean;
var i : integer;
begin
result:=false;
for i:=0 to length(game.objs)-1 do
 if (i<>discard) then
 with game.objs[i] do
  if typo>0 then
   if (cx>=xx) and (cx<=xx+32) and
      (cy>=yy) and (cy<=yy+31) then
       begin
       if (game.objs[discard].stall=0) then
        if (typo>=100) and (game.objs[discard].typo=1) then
          begin
          killjoffa(discard,i);
//          result:=true;
          exit;
          end;
      if yy<game.objs[discard].yy-26 then
       if stall=0 then
        if (typo=1) and (game.objs[discard].typo>=100) then
          begin
          killjoffa(i,discard);
//          result:=true;
          exit;
          end;
       if (typo>=100) and (game.objs[discard].typo=30) then
         begin
         tag:='MOS';
         game.objs[discard].typo:=0;
         ax:=ax+game.objs[discard].vx;
         ay:=-2; oy:=yy;
         playsoundfx(xx+16,yy+16,4);
         with game.gamma do
          begin
          r:=1;g:=1.5; b:=1;
          end;
         exit;
         end;

      if (game.objs[discard].pusher) and (pusher) and
         (pushable) and (game.objs[discard].pushable) then result:=true;

      if (pusher) and (game.objs[discard].pushable) then result:=true;
      if (game.objs[discard].pusher) and (pushable) then
       if crashx then
        begin
        crashx:=false;
        moveobject(i,dx,0,level+1);
//        ax:=ax+dx;
        crashx:=true;
        end else
        begin
        moveobject(i,dx,0,level+1);
//        ax:=ax+dx;
        if crashx then crashx:=true;
       end;
      end;
end;

function tmainform.pushobjsy(cx,cy : single; var dy : single; discard,level : integer) : boolean;
var i : integer;
begin
result:=false;
for i:=0 to length(game.objs)-1 do
 if (i<>discard) then
 with game.objs[i] do
  if typo>0 then
   if (cx>=xx) and (cx<=xx+32) and
      (cy>=yy) and (cy<=yy+31) then
       begin
       if (typo=40) and (dy<0) then // [?] boks
        begin
        pic:=pic+1;inc(typo);
        stall:=0;result:=true;
        playsoundfx(xx+16,yy+16,2);

        if itag<>-1 then
         with game.objs[CreateObjectOfBlock(itag,game.objs[i].xx,game.objs[i].yy-32)] do
          begin
          ay:=-8;
          oy:=yy;
          gravity:=true;
          end
        else
        with game.objs[gethandle] do
         begin
         xx:=game.objs[i].xx;
         yy:=game.objs[i].yy-32;
         ay:=-8;
         oy:=yy;
         pic:=2*16+15;
         typo:=78;
         if isblock(trunc(xx)+16,trunc(yy)+16)>0 then
          begin
          blockcrash:=true;
          typo:=98;
          PlaySoundFX(xx,yy,3);
          stall:=255;
          invince:=255;
          ay:=-2;
          oy:=yy;
          end;
         end;{}
        exit;
        end;{}

       if (istrampo) and (dy>0) then
        begin
        stall:=0;
        game.objs[discard].ay:=-16;dy:=0;
        game.objs[discard].oy:=game.objs[discard].yy;
        playsoundfx(xx+16,yy+16,1);
        exit;
        end;

       if (typo>=100) and (game.objs[discard].typo<100) then
        if ((dy>0) and (yy-28>game.objs[discard].yy)) or (game.objs[discard].typo=30) then
         begin
         game.objs[discard].ay:=-8;
         game.objs[discard].oy:=game.objs[discard].yy;
         dy:=0;
         killenemy(i);
         exit;
         end;

      if (game.objs[discard].pusher) and (pusher) and
         (pushable) and (game.objs[discard].pushable) then result:=true;

      if (pusher) and (game.objs[discard].pushable) then
       begin
       result:=true;
       if (dy>0) and (yy-31>game.objs[discard].yy) then
        begin
        game.objs[discard].ox:=game.objs[discard].ox+vx;
        moveobject(discard,vx,0,level+1);
        end;
       end;
      if (game.objs[discard].pusher) and (pushable) then
       if crashy then
        begin
        crashy:=false;
        moveobject(i,0,dy,level+1);
        crashy:=true;
//        ay:=ay+dy;
        end else
        begin
        moveobject(i,0,dy,level+1);
//        ay:=ay+dy;
        if crashy then crashy:=true;
       end;
      end;
end;




Procedure TMainForm.MoveObject(obj : integer; dvx,dvy : single; level : integer);
var  l : integer;
     len,dx,dy : single;

procedure movestep;
var i : integer;
begin
with game.objs[obj] do
 begin
 if (pusher) or (pushable) then
   for i:=0 to 1 do
    begin
    if not crashx then crashx:=pushobjsx(xx+dx+16,yy+i*31,dx,obj,level+1);
    if not crashy then crashy:=pushobjsy(xx+16,yy+dy+i*31,dy,obj,level+1);
    end;


 if not blockcrash then
  for i:=1 to 31 do
   begin
   if (not crashy) and (isblock(trunc(xx+16),trunc(yy+dy)+i)>0) then crashy:=true;
   if (not crashx) and (dx<>0) then
    if (isblock(trunc(xx+dx+16),trunc(yy)+i)>0) then
     if i>=26 then
      begin
       if ((dy=0) or (crashy)) and (dvy>=0) then
        begin
        if crashy then
         begin // flytte fyren opp 1 hakk
         crashy:=false;
         moveobject(obj,0,-1,level+1);
         crashy:=true;
         end else moveobject(obj,0,-1,level+1);
        end else crashx:=true;
      end else crashx:=true;
   end;

 if crashx then dx:=0 else xx:=xx+dx;
 if crashy then dy:=0 else yy:=yy+dy;
 end;
end;

begin
if level<32 then
 with game.objs[obj] do
  if (dvx<>0) or (dvy<>0) then
   begin
   
   if abs(dvx)>abs(dvy) then len:=abs(dvx) else len:=abs(dvy);
//   len:=sqrt(sqr(dvx)+sqr(dvy));

   dx:=dvx/len;
   dy:=dvy/len;
   for l:=1 to trunc(len) do movestep;
   dx:=dx*frac(len);
   dy:=dy*frac(len);
   movestep;
   end;
end;


Procedure TMainForm.ProcessObjs;
var da,aa,i: integer;

begin
for i:=0 to length(game.objs)-1 do
 with game.objs[i] do
 if (typo<>0) then
  if (xx-game.scrollx>-100) and (xx-game.scrollx<mainform.dxdraw1.width+100) and
    (yy-game.scrolly>-100) and (yy-game.scrolly<mainform.dxdraw1.height+100) or (typo=4) then
  begin


  currentobj:=i;
  invince:=0;
  if abs(vx)<0.15 then vx:=0;{}
{  if abs(vy)<0.25 then vy:=0;{}
  vx:=vx+ax;
  vy:=vy+ay;
  if typo=30 then ay:=1.20;

  aa:=isblock(trunc(xx+16),trunc(yy+16));
  if (-aa>=5*16) and (-aa<8*16) then begin;if vy>0 then vy:=vy /2;vx:=vx/1.3;ay:=0.61;end else
   if (vy>1) and (length(tag)=3) then
    if (tag[1]+tag[2]='H0') then
     begin
     vy:=vy/1.2;
     ay:=0.51;
     tag[3]:=inttostr((strtoint(tag[3])+1) mod 4)[1];
     end;

  if vy>12 then vy:=12;
  if vy<-20 then vy:=-20;


  crashx:=false; crashy:=false;



 if typo=4 then
  begin
  ay:=0;  ax:=0;
 // Oppover/Nedover/Venstre/Hyre
  if (trunc(xx) shr 5 shl 5=trunc(xx)) or (trunc(yy) shr 5 shl 5=trunc(yy)) then
   begin
   da:=-isblock(trunc(xx+8),trunc(yy+8));
   if da=15 then tag:='H';
   if da=12 then tag:='N';
   if da=14 then tag:='V';
   if da=13 then tag:='O';

   if da=8 then tag:='NH';
   if da=9 then tag:='OV';
   if da=10 then tag:='NV';
   if da=11 then tag:='OH';
   end;

  if tag='H' then begin;vx:=liftspeed;  vy:=0;end;
  if tag='V' then begin;vx:=-liftspeed; vy:=0;end;
  if tag='O' then begin;vx:=0;          vy:=-liftspeed;end;
  if tag='N' then begin;vx:=0;          vy:=liftspeed;end;

  if tag='NH' then begin;vx:=liftspeed;  vy:=liftspeed;end;
  if tag='OV' then begin;vx:=-liftspeed; vy:=-liftspeed;end;
  if tag='NV' then begin;vx:=-liftspeed; vy:=liftspeed;end;
  if tag='OH' then begin;vx:=liftspeed;  vy:=-liftspeed;end;


  ax:=0;  ay:=0;
  end;


  ox:=xx; oy:=yy;
  ovy:=vy;
  if gravity then ay:=0.6 else ay:=0;// gravity
  MoveObject(i,vx,vy,0);
//  if not crashx then
  vx:=xx-ox;
//  if ovy=vy) and (not crashy) then
  vy:=yy-oy;

  if crashx then vx:=0;
  if crashy then vy:=0;

  ax:=0;
  py:=0;

  if typo=78 then
   begin
//    game.objs[handl].gravity:=false;
   py:=-sin((xx*0.77+yy*0.77+stall)/32*3.14)*4;
   inc(stall);
   end;


  if (typo=40) or (typo=41) then
   begin
   if stall<50 then inc(stall);
   py:=-sin(stall/(8)*3.14)*4 * (50-stall)/50;
   ay:=0;
   end;




  if istrampo then // (trampo topp)
   begin
   if stall<100 then inc(stall);
   py:=sin(stall/(8)*3.14)*6 * (100-stall)/100+3;
   end;


  if typo=1 then
   begin //Joffa da man
   if (yy>game.level.info.height*32) then killjoffa(i,i);
   if isbonus(round(xx),round(yy))<>-1 then
    with game.objs[isbonus(round(xx),round(yy))] do
     begin
     blockcrash:=false;
     if (pic>=-4) and (pic<=-2) then
      begin
      game.objs[i].tag:='H'+tag+'1';
      PlaySoundFX(xx,yy,2);
      end else PlaySoundFX(xx,yy,3);

     typo:=98;
     stall:=255;
     invince:=255;
     vy:=-2;
     end;
   if stall=0 then
    begin
    case isblock(trunc(xx+16),trunc(yy+32)) of
     8*16..8*16+15 :
       begin
       killjoffa(i,i);
//       if tag='' then typo:=99 else tag:='';
//       pic:=8; stall:=255; vy:=-8;
       end;
      end;
    case isblock(trunc(xx+16),trunc(yy-1)) of
     8*16..8*16+15 :
       begin
       killjoffa(i,i);
       end;
     end;
    end;

   if stall>0 then dec(stall);
   if stall shr 4 shl 4= stall shr 3 shl 3 then invince:=128 else invince:=0;
   if stall=0 then invince:=0;
   if length(tag)=3 then
    if (tag[1]='H') and (tag[2]<>'0') then
     begin
     tag[3]:=inttostr((strtoint(tag[3])+1) mod 4)[1];
     end;
//   if invince>0 then dec(invince);
   // player
   if vy>2 then if vy>3 then pic:=7 else pic:=0;
   if vy<-2 then if vy<3 then pic:=6 else pic:=0;
   end;


 if typo=30 then
  begin
  if crashx then //typo:=0;
   direction:=integer(direction=0);
  if direction=0 then vx:=12 else vx:=-12;
  ax:=0;
  if (isblock(trunc(xx+12),trunc(vy+yy+33))>0)or
     (isblock(trunc(xx+31-12),trunc(vy+yy+33))>0) then ay:=-8;
  dec(stall,4);
  invince:=stall;
  if stall<=0 then typo:=0;
  end;
// ai
 if typo>=100 then
  begin
  pic:=pic-(typo-100+7)*16;
  if (random(4)=0) and (crashx) then direction:=integer(direction=0);

  if isblock(trunc(xx+16),trunc(yy+16))=-15 then direction:=0;
  if isblock(trunc(xx+16),trunc(yy+16))=-14 then direction:=1;

  if (isblock(trunc(xx+16),trunc(vy+yy+33))>0) then
   if (typo=103) and (random(4)=0) then begin;ay:=-6;PlaySoundFX(xx,yy,0);end;


  if isblock(trunc(xx+16),trunc(yy+16))=-13 then
    if (isblock(trunc(xx+16),trunc(vy+yy+31))>0) then begin;vy:=0;ay:=-8;PlaySoundFX(xx,yy,0);end;

  if (stall=-500) then stall:=20;

  if stall<=0 then
   begin
//   if (crashy) and (random(5)=1) then stall:=20;
   if random(5)*random(5)*random(5)*random(5)=1 then stall:=20;
   if (random(5)*random(5)*random(5)=1) then
    if (isblock(trunc(xx+16),trunc(vy+yy+33))>0) then begin;ay:=-6;PlaySoundFX(xx,yy,0);end;

//
//   if direction=1 then begin;ax:=-0.35;end;
//   if direction=0 then begin;ax:=0.35;end;
   ax:=0.17;
   if typo=104 then ax:=0.18;
   if typo=100 then ax:=0.16;
   if typo=102 then ax:=0.19;

   ax:=ax*(1-direction*2);
   end;
  dec(stall);

//  if invince>0 then dec(invince);
   if vx=0 then pic:=0 else
    begin
    pic:=pic+0.2;
    if pic>=6 then pic:=1;
    end;
   if vy>2 then if vy>3 then pic:=7 else pic:=0;
   if vy<-2 then if vy<3 then pic:=6 else pic:=0;
  if (stall>0) and (tag<>'DD') then pic:=9;

  pic:=pic+(typo-100+7)*16;
  if typo=102 then begin;vy:=0;ay:=0;end;
  end;

  aa:=isblock(trunc(xx+16),trunc(yy+16));
  if (-aa>=5*16) and (-aa<8*16) then invince:=128;

  if typo=1 then
   if isdoor(round(xx),round(yy))<>-1 then
         LoadLevel(game.level.filename+game.objs[isdoor(round(xx),round(yy))].tag);


  if typo=99 then
   begin
   if stall>0 then dec(stall,3);
   if stall<=0 then typo:=0;
   if invince<stall then invince:=stall;
   end;

  if typo=98 then
   begin
   vy:=-2;
   if stall>0 then dec(stall,4);
   if stall<=0 then typo:=0;
   if invince<stall then invince:=stall;
   end;

//  if typo<>4 then
  if crashy then
   begin
   if (typo=1) and (pic=7) then vx:=vx*0.93
                           else vx:=vx*0.90;

   end else vx:=vx*0.92;


{  if vy>1 then vy:=vy-0.10;
  if vy<-1 then vy:=vy+0.10;{}
  end;
end;

//var j,jj : integer;
Procedure ObjDraw;
var i : integer;
begin
for i:=0 to length(game.objs)-1 do
 with game.objs[i] do
 if (typo<>0) then
  if (pic>=0) then
   begin
   if (invince=0) then
     mainform.dximagelist1.items[2+direction].Draw(mainform.dxdraw1.surface,trunc(xx)-game.scrollx,trunc(yy+py)-game.scrolly,trunc(pic+0))
      else
     mainform.dximagelist1.items[2+direction].drawalpha(mainform.dxdraw1.surface,bounds(trunc(xx)-game.scrollx,trunc(yy+py)-game.scrolly,32,32),trunc(pic+0),invince);

// Helmet draw
   if typo=1 then
    begin
    if length(tag)=3 then
     if tag[1]='H' then
      begin
      mainform.dximagelist1.items[2+direction].draw(mainform.dxdraw1.surface,trunc(xx)-game.scrollx,trunc(yy+py)-game.scrolly,19);
      mainform.dximagelist1.items[2+direction].draw(mainform.dxdraw1.surface,trunc(xx)-game.scrollx,trunc(yy+py)-game.scrolly-32,16*3+strtoint(tag[2])*4+strtoint(tag[3]));
      end;
    end;
   end else //heiser
     mainform.dximagelist1.items[1+direction].draw(mainform.dxdraw1.surface,trunc(xx)-game.scrollx,trunc(yy+py)-game.scrolly,trunc(-pic+0))
end;




Procedure Resetlevel;
var l,xx,yy : integer;
begin
for l:=0 to game.level.info.layers-1 do
 for xx:=0 to game.level.info.width-1 do
  for yy:=0 to game.level.info.height-1 do
   game.level.l[l][xx,yy]:=-1;
end;

Procedure ResetObjs;
var i : integer;
begin
for i:=0 to length(game.objs)-1 do
 begin
 zeromemory(@game.objs[i],sizeof(game.objs[i]));
 end;
end;


Procedure BackgroundDraw(scrollx,scrolly,layer : integer);
var dx,dy,sx,sy,xx,yy,w,h : integer;
    aa : smallint;
begin
if layer=0 then
 if game.level.info.scrollbackground>0 then
  begin
  w:=mainform.dximagelist1.items[0].width;
  h:=mainform.dximagelist1.items[0].height;
  sx:=scrollx div game.level.info.scrollbackground;
  sy:=scrolly div game.level.info.scrollbackground;
  dx:=(sx div w) *w;
  dy:=(sy div h) *h;
//  mainform.dxdraw1.surface.bltfast(0,0,bounds(sx-dx,sy-dy,640-sx+dx,480-sy+dy),DDBLTFAST_NOCOLORKEY or DDBLTFAST_WAIT,mainform.dximagelist1.items[0].patternsurfaces[0]);//or DDBLTFAST_WAIT

  mainform.dximagelist1.items[0].draw(mainform.dxdraw1.surface,(-sx)+dx,-sy+dy,0);
  mainform.dximagelist1.items[0].draw(mainform.dxdraw1.surface,(-sx)+dx+w,-sy+dy,0);
  mainform.dximagelist1.items[0].draw(mainform.dxdraw1.surface,(-sx)+dx+w,-sy+dy+h,0);
  mainform.dximagelist1.items[0].draw(mainform.dxdraw1.surface,(-sx)+dx,  -sy+dy+h,0);
  end else
  mainform.dxdraw1.surface.bltfast(0,0,bounds(0,0,640,480),DDBLTFAST_NOCOLORKEY or DDBLTFAST_WAIT,mainform.dximagelist1.items[0].patternsurfaces[0]);//or DDBLTFAST_WAIT


sx:=scrollx shr 5;
sy:=scrolly shr 5;
dx:=-scrollx+sx shl 5;
dy:=-scrolly+sy shl 5;
for xx:=0 to mainform.dxdraw1.display.width shr 5+1 do
 for yy:=0 to mainform.dxdraw1.display.height shr 5 +1 do
  begin
  aa:=game.level.l[layer][(xx+sx) mod game.level.info.width,(yy+sy) mod game.level.info.height];
  if aa>-1 then
   begin
   mainform.dximagelist1.items[1].draw(mainform.dxdraw1.surface,xx shl 5+dx,yy shl 5+dy,aa);
   end else
   if (-aa>=16*5) and (-aa<16*8) then
    begin
    mainform.dximagelist1.items[1].draw(mainform.dxdraw1.surface,xx shl 5+dx,yy shl 5+dy,-aa);
    end;
  end;
end;



Procedure TMainForm.PlayerInput(PlayerObj : integer; dxistates : tdxinputstates);
var aa : integer;
begin
Slide:=False;

if game.objs[playerobj].typo<>1 then exit;
if (isLeft in dxistates) and not (isDown in dxistates) then
 begin
 game.objs[PlayerObj].ax:=-0.35;
 game.objs[PlayerObj].direction:=1;
 end;
if (isRight in dxistates) and not (isDown in dxistates) then
 begin
 game.objs[PlayerObj].ax:=0.35;
 game.objs[PlayerObj].direction:=0;
 end;

if ((isright in dxistates) or (isleft in dxistates)) and not (isdown in dxistates) then
 with game.objs[PlayerObj] do
//  if vx=0 then pic:=0 else
   begin
   pic:=pic+0.35;
   if pic>=6 then pic:=1;
   end else game.objs[playerobj].pic:=0;

if (isUp in dxistates) then
 with game.objs[PlayerObj] do
//  if (isblock(trunc(xx+16),trunc(vy+yy+33))>0) then
// if {(ovy>0) and} (isblock(trunc(xx+16),trunc(yy+33))>0) then
 if (crashy) and (ovy>=0) then
  begin
//  mainform.dxsfx1.items[0].play(false);
  PlaySoundFX(xx,yy,0);
  ay:=-11-abs(vx)*0.3;
  vy:=0;
  end else if vy>-4 then
   begin
   aa:=isblock(trunc(xx+16),trunc(yy+16));
    if (-aa>=5*16) and (-aa<8*16) then
     begin
     ay:=-1;
     end else
    if length(tag)=3 then
     if (tag[1]+tag[2]='H0') then
      begin
      ay:=-0.8;
      end;
   end;

if not (isButton1 in dxistates) then game.fireup:=true;

if (isButton1 in dxistates) and (game.nextfire<=0) and game.fireup then
 with game.objs[PlayerObj] do
  if (length(tag)=3) then
   if tag[1]+tag[2]='H2' then
    with game.objs[gethandle] do
     begin
     if game.objs[playerobj].direction<>0 then
       xx:=game.objs[PlayerObj].xx-32 else xx:=game.objs[PlayerObj].xx+32;
     xx:=xx+game.objs[PlayerObj].vx;
     yy:=game.objs[PlayerObj].yy-16;
     if isblock(trunc(xx),trunc(yy+30))>0 then typo:=0 else
      begin
      direction:=game.objs[PlayerObj].direction;
      pic:=18;
      pushable:=true;
      pusher:=false;

      if isup in dxistates then vy:=-10 else
       if isdown in dxistates then vy:=5 else vy:=-1;

      ay:=0;ax:=0;vx:=0;
      typo:=30;
      stall:=255;
      game.fireup:=false;
      game.nextfire:=20;
      PlaySoundFX(xx,yy,6);
      end;
     end;

if (isUp in dxistates) then
 with game.objs[PlayerObj] do
  if (length(tag)=3) then
   if (tag[1]+tag[2]='H0') then
    tag[3]:=inttostr((strtoint(tag[3])+1) mod 4)[1];

if (isDown in dxistates) and (game.objs[playerobj].vy>=0) then
 with game.objs[playerobj] do
  begin
  moveobject(playerobj,0,abs(vx),1);
  if isblock(round(xx)+16,ceil(yy)+32)>0 then
    for aa:=1 to 5 do
     if isblock(round(xx)+16+aa,round(yy)+32)=-1 then
      begin
      direction:=0;
      ax:=0.5;
//      ay:=2;
      slide:=true;
      pic:=7;
      break;
      end else
     if isblock(round(xx)+16-aa,round(yy)+32)=-1 then
      begin
      slide:=true;
      direction:=1;
      ax:=-0.5;
//      ay:=2;
      pic:=7;
      break;
      end;
 end;

with game.objs[playerobj] do
 if (isdown in dxistates) and (not crashx) and (abs(vx)>2) then pic:=7;{}
end;


procedure TMainForm.PlayGame;
var d : single;
    s : tdxinputstates;
    scorestr : string;
begin

with game.gamma do
 begin
 r:=1-(1-r)*0.95;
 g:=1-(1-g)*0.95;
 b:=1-(1-b)*0.95;
 end;

mainform.updategamma;

if not mainform.dxdraw1.candraw then exit;

// bakgrunn

if (game.nextfire>=0) then dec(game.nextfire);

mainform.dxinput1.Update;


if (isbutton1 in mainform.dxinput1.States) then
 if game.objs[myhandle].typo<>1 then
  begin
  with game do score:=levelscore;
  loadlevel(game.level.currentfile);
  end;



// daah
s:=mainform.dxinput1.states;
if not (isup in s) and (mainform.dxinput1.keyboard.keys[17]) then s:=s+[isup];
if not (isButton1 in s) and (mainform.dxinput1.keyboard.keys[18]) then s:=s+[isButton1];{}

// inc(mainform.dxinput1.states.isfire);

PlayerInput(myhandle, s);

d:=0.90;
game.scrollx:=round(game.scrollx*d + (game.objs[myhandle].xx-mainform.dxdraw1.display.Width / 2)*(1-d));
game.scrolly:=round(game.scrolly*d + (game.objs[myhandle].yy-mainform.dxdraw1.display.height / 2)*(1-d));

{if game.scrollx>game.objs[myhandle].xx-320 then dec(game.scrollvx);
if game.scrollx<game.objs[myhandle].xx-320 then inc(game.scrollvx);
if abs(game.scrollvx)>5 then game.scrollvx:=5*(game.scrollvx div abs(game.scrollvx));

game.scrollx:=game.scrollx+game.scrollvx;

//if game.scrolly>game.objs[myhandle].yy-320 then game.scrollvy:=-1;
//if game.scrolly<game.objs[myhandle].yy-320 then game.scrollvy:=1;
//game.scrolly:=game.scrolly+game.scrollvy;}



if game.scrolly<0 then game.scrolly:=0;
if game.scrolly>game.level.info.height*32-mainform.dxdraw1.display.height then game.scrolly:=game.level.info.height*32-mainform.dxdraw1.display.height;
if game.scrollx<0 then game.scrollx:=0;
if game.scrollx>game.level.info.width*32-mainform.dxdraw1.display.width then game.scrollx:=game.level.info.width*32-mainform.dxdraw1.display.width;


with game.objs[myhandle] do
 if isbutton2 in s then
  begin
  ax:=ax*1.75;
//  ax:=ax*1.5;
  end;

processobjs;

if slide then
with game.objs[myhandle] do
 begin
// vy:=vy+0.51;
// MoveObject(myhandle,0,15,0);
 end;

//game.scrollx:=game.objs[myhandle]-160;


with game do
 begin
 BackgroundDraw(round(scrollx/1.05),round(scrolly/1.05),0);
 BackgroundDraw(scrollx,scrolly,1);
 objdraw;
 BackgroundDraw(round(scrollx*1.05),round(scrolly*1.05),2);
 with dxdraw1.surface.canvas do
  begin
  font.name:='Arial';
  font.size:=8;
  font.style:=[fsbold];
  visiblescore:=round(visiblescore*9/10+score/10);
  scorestr:=' '+inttostr(visiblescore)+' ';
  if visiblescore>0 then
   textout(630-textwidth(scorestr),10,scorestr);
  release;
  end;
 end;



{with mainform.dxdraw1.surface.canvas do
 begin
// textout(0,0,'LECSJDO');

 textout(0,0,inttostr(mainform.dxtimer1.framerate));
//  textout(0,20,inttostr((mainform.dximagelist1.items[4].Picture.Bitmap.Canvas.Pixels[top,left])));
 release;
 end;{}
mainform.dxdraw1.flip;
inc(frame);
end;

procedure TMainForm.LoadWorld(dff : string);
begin
game.level.filename:=dff;
loadlevel(dff);
end;



procedure tmainform.loadgfx;
var xx : integer;
begin
if fileexists('gfx\'+game.level.info.background) then
 begin
 mainform.dximagelist1.items[0].Picture.LoadFromFile('gfx\'+game.level.info.background);
 mainform.dximagelist1.items[1].Picture.LoadFromFile('gfx\'+game.level.info.backobjs);
 mainform.dximagelist1.items[2].Picture.LoadFromFile('gfx\'+game.level.info.sprites);
 mainform.dximagelist1.items[3].Picture.LoadFromFile('gfx\'+game.level.info.sprites);
 end else
 begin //internett zip-fix   s
 mainform.dximagelist1.items[0].Picture.LoadFromFile(extractfilepath(application.exename)+game.level.info.background);
 mainform.dximagelist1.items[1].Picture.LoadFromFile(extractfilepath(application.exename)+game.level.info.backobjs);
 mainform.dximagelist1.items[2].Picture.LoadFromFile(extractfilepath(application.exename)+game.level.info.sprites);
 mainform.dximagelist1.items[3].Picture.LoadFromFile(extractfilepath(application.exename)+game.level.info.sprites);
 end;
calcbmask(1);
if dxdraw1.display.BitCount = 8 then
 begin
 fiximg8(0);
 fiximg8(1);
 fiximg8(2);
 end;


if (dxdraw1.display.BitCount = 16) or (dxdraw1.display.bitcount = 15) then
 begin
 fiximg16(0);
 fiximg16(1);
 fiximg16(2);
 fiximg16(4);
 end;

flipimg(2,3);

for xx:=0 to 3 do
 begin
 mainform.dximagelist1.Items[xx].picture.Bitmap.PixelFormat:=pf24bit;
 mainform.DXImageList1.Items[Xx].restore;
 end;
end;



Procedure tmainform.loadlevel(levelfilename : string);
var filehandle,l,handl,dy,xx,yy : integer;
    a : tcollectionitem;
    filename,tag : string;
begin
if myhandle<length(game.objs) then tag:=game.objs[myhandle].tag;

game.levelscore:=game.score;
visiblescore:=game.score;
with game.gamma do
 begin
 r:=0; g:=0; b:=0;
 end;
resetlevel;
resetobjs;{}
if fileexists('l\'+levelfilename+'.l') then
 filename:='l\'+levelfilename+'.l' else
 filename:=levelfilename+'.l';

game.level.currentfile:=levelfilename;

  if not fileexists(filename) then
  begin
    menuform.quit.click;
    showmessage('404! file not found!'+filename);
    Exit;
  end;

game.level.info.startx:=0;
game.level.info.starty:=0;

randomize;
setlength(game.objs,0);

//load(dff);

filehandle:=fileopen(filename,fmOpenRead);
if filehandle<0 then begin;messagedlg('Couldn''t open level file:'+filename,mtError,[mbAbort],0);exit;end;
//assignfile(ff,f);
//reset(ff,1);

//blockread(ff,game.level.info,sizeof(levelextrainfotype));
fileread(filehandle,game.level.info,sizeof(levelextrainfotype));

with game.level do setlength(l,info.layers,info.width,info.height);
for l:=0 to game.level.info.layers-1 do
   for dy:=0 to game.level.info.width-1 do
     fileread(filehandle,game.level.l[l][dy,0],(game.level.info.height*2));
//     blockread(ff,game.level.l[l][dy,0],(game.level.info.height*2));

fileclose(filehandle);


//closefile(ff);{}

for yy:=0 to game.level.info.height-1 do
 for xx:=0 to game.level.info.width-1 do
  with game.level do
   begin
   if (l[GameLayer][xx,yy]>=8) and (l[GameLayer][xx,yy]<=15) then l[GameLayer][xx,yy]:=-l[GameLayer][xx,yy];
   if (l[GameLayer][xx,yy]>=5*16) and (l[GameLayer][xx,yy]<8*16) then
    begin
    l[GameLayer][xx,yy]:=-l[GameLayer][xx,yy];
    end;
   if CreateObjectofBlock(l[gamelayer][xx,yy],xx shl 5,yy shl 5)<>-1 then l[gamelayer][xx,yy]:=-1;
   if CreateObjectofBlock(l[2][xx,yy],xx shl 5,yy shl 5)<>-1 then l[2][xx,yy]:=-1;
   end;
//------------------------------------------------------------
myhandle:=gethandle;
game.objs[myhandle].pic:=0;
game.objs[myhandle].typo:=1;
game.objs[myhandle].stall:=250;
game.objs[myhandle].pushable:=true;
game.objs[myhandle].pusher:=true;
game.objs[myhandle].xx:=game.level.info.startx;
game.objs[myhandle].yy:=game.level.info.starty;
//showmessage('back;'+game.level.info.background);
//mainform.dximagelist1.Items.restore;
loadgfx;

game.scrollx:=game.level.info.startx-320;
game.scrolly:=game.level.info.starty-240;
game.objs[myhandle].tag:=tag;

mainform.DXSound1.Restore;
{if fileexists('mfx\itf.wav') then
 begin
 a:=mainform.dxmusic1.Items.Add;
 mainform.dxmusic1.Items.Items[a.Index].wave.loadfromfile('mfx\itf.wav');
 mainform.dxmusic1.items.items[a.index].Restore;
// mainform.dxmusic1.Items.Items[a.index].Buffer.LoadFromWave(mainform.dxmusic1.Items.Items[a.Index].wave);
 mainform.dxmusic1.Items.Items[a.index].looped:=true;
 mainform.dxmusic1.items.items[a.index].play(false);
 end;{}
end;

//type atype = array[0..32*32*4] of byte;

Procedure TMainForm.InitGame;
begin
game.score:=0;
initsnow;
loadworld('openland');
playing:=true;
end;

Procedure TMainForm.InitApp;
var a : string;
begin
{mainform.top:=0;
mainform.left:=0;{}
//screen.cursor:=crnone;
//      DXDraw1.Cursor := crNone;

mainform.clientwidth:=640;
mainform.clientheight:=480;


flipimg(1,2);
dximagelist1.items.Restore;
end;

    
procedure ShowIntro;
begin
mainform.dximagelist1.items[4].draw(mainform.dxdraw1.surface,0,0,0);
mainform.dxdraw1.flip;
//
{
if introframe=0 then
 if fileexists('mfx\joffatun.wav') then
  begin
  mainform.dxmusic1.Items.Clear;
//  a:=mainform.dxmusic1.Items.Add;
  with mainform.dxmusic1.Items.Items[mainform.dxmusic1.Items.Add.Index] do
   begin
   wave.loadfromfile('mfx\joffatun.wav');
//   wave.SetPCMFormat(44100,16,2);
   Restore;
   looped:=true;
   play(true);
//   mainform.dxsound1.
   end;
  end;{}

inc(introframe);
end;

procedure TMainForm.DXTimer1Timer(Sender: TObject; LagCount: Integer);
begin
dxinput1.Keyboard.Update;
{if dxinput1.Keyboard.Keys[0] then
 begin

 end;{}
if playing then playgame;
if not playing then showintro else introframe:=0;
end;

procedure TMainForm.DXPlay1Message(Sender: TObject; From: TDXPlayPlayer;
  Data: Pointer; DataSize: Integer);
var i : integer;
begin
for i:=0 to maxplayers-1 do
 if game.players[i].id=from.ID then
  begin

  end;
end;

procedure TMainForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key=VK_ESCAPE then
  begin
    MenuForm.Left:=Left+(Width-MenuForm.Width) Div 2;
    MenuForm.Top:=Top+(Height-MenuForm.Height) Div 2;
    MenuForm.ShowModal;
  end;
  if key=VK_F4 then debugform.show;

  if (ssAlt in Shift) and (Key=VK_RETURN) then SwitchMode;
end;

procedure TMainForm.DXDraw1InitializeSurface(Sender: TObject);
begin
if dofullscreen in mainform.dxdraw1.Options then
 begin
   mainform.BorderStyle:=bsnone;
 end else mainform.borderstyle:=bssingle;{}
end;

procedure TMainForm.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key=VK_F4 then debugform.hide;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Filemode := fmOpenRead;
end;

procedure TMainForm.DXDraw1Click(Sender: TObject);
begin
  if not playing then 
end;

end.
